"""Instruction pattern definitions for ENG1448 16-bit processor
   (c) 2020-2024 Wouter Caarls, PUC-Rio
"""

defs = {
        'mov':   [('1001',         '0000', 'RR'), # add d, s, 0
                  ('0000',             '', 'R8')],
        'movt':  [('0001',             '', 'R8')],
        'b':     [('00100000',         '', 'B')],
        'bz':    [('00100001',         '', 'B')],
        'beq':   [('00100001',         '', 'B')],
        'bnz':   [('00100010',         '', 'B')],
        'bne':   [('00100010',         '', 'B')],
        'bcs':   [('00100011',         '', 'B')],
        'bhs':   [('00100011',         '', 'B')],
        'bcc':   [('00100100',         '', 'B')],
        'blo':   [('00100100',         '', 'B')],
        'blt':   [('00100101',         '', 'B')],
        'bge':   [('00100110',         '', 'B')],
        'jmp':   [('10001110',     '0000', 'R'), # add pc, s, 0
                  ('0011',             '', '2')], 
        
        'ldr':   [('0100',         '0000', 'RA'),
                  ('0100',             '', 'RA4')],
        'str':   [('0101',         '0000', 'RA'),
                  ('0101',             '', 'RA4')],
        'push':  [('011000001110',     '', 'R')],
        'ret':   [('0111111111100000', '', '')],   # pop pc
        'pop':   [('0111',     '11100000', 'R')],

        'add':   [('1000',             '', 'RRR'),
                  ('1001',             '', 'RR4')],
        'sub':   [('1010',             '', 'RRR'),
                  ('1011',             '', 'RR4')],

        'shft':  [('1100',             '', 'RRS')],
        'and':   [('1101',             '', 'RRR')],
        'or':    [('1110',             '', 'RRR')],
        'xor':   [('1111',             '', 'RRR')],

        '.org':  [('',                 '', '6')],
        '.dw':   [('',                 '', '6')],
        '.section': [('',              '', 'X')],
        '.equ':  [('',                 '', 'X6')]
       }
